package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20032ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20032ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20032CreatePalletCode extends ProtBase {
	
	private final short iTaskCode20032 = 20032;
	private Gson gson;
	private Jin20032ResBean resBean;
	private String package_label_id;
	
	public Jin20032CreatePalletCode() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20032ResBean getResBean(){
		return this.resBean;
	}
	
	public void createPalletCode(SocketCreate create, Jin20032ReqBean reqBean) throws IOException {
		package_label_id = reqBean.getPackage_label_id();
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
                         DataInputStream dis, Jin20032ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20032, "开始请求信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	static int cTest = 0;
	
	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20032, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20032, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20032ResBean.class);
			resBean.setPackage_label_id(package_label_id);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Jin20032ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20032, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
